//------------------------------------------------------------------------------------------------------------------------
// Class       : BP_ScriptObject
// Author      : BehemothProgrammer
// Description : Base class for all actors
//------------------------------------------------------------------------------------------------------------------------

abstract class BP_ScriptObject : ScriptObject
{
    kActor @self;
	int state;
	int prevState;
	float stateStartTime;
	float stateEndTime;
	//------------------------------------------------------------------------------------------------------------------------
    BP_ScriptObject(kActor @actor)
    {
        @self = actor;
    }
	//------------------------------------------------------------------------------------------------------------------------
    void OnSpawn()
    {
		
    }
	//------------------------------------------------------------------------------------------------------------------------
    void OnTick()
    {
		
    }
	//------------------------------------------------------------------------------------------------------------------------
	void SetState(const int newState)
	{
		prevState = state;
		state = newState;
		stateStartTime = Time::FromNow(0.0f);
		stateEndTime = stateStartTime;
		OnStateChange();
	}
	//------------------------------------------------------------------------------------------------------------------------
	void OnStateChange()
	{
	}
	//------------------------------------------------------------------------------------------------------------------------
};
