//------------------------------------------------------------------------------------------------------------------------
// Class       : BP_KeyPlaque
// Author      : BehemothProgrammer
// Description : A key plaque is darkened until it is triggered then it becomes it's normal color.
// OnTrigger   : Removes the dark effect on the plaque and is persistent. Subsequent triggers do nothing.
//
// Parameters  : 
//------------------------------------------------------------------------------------------------------------------------

class BP_KeyPlaque : BP_ScriptObject
{
	//------------------------------------------------------------------------------------------------------------------------
    BP_KeyPlaque(kActor @actor)
    {
		super(actor);
    }
	//------------------------------------------------------------------------------------------------------------------------
    void OnBeginLevel()
    {
		if (self.IsPersistentMarked())
		{
			self.Flags() |= AF_ACTIVATED;
		}
		else
		{
			self.RunFxEvent("PortalPlaque_Setup");
		}
		self.Flags() |= AF_INVINCIBLE;
    }
	//------------------------------------------------------------------------------------------------------------------------
    void OnActivate()
    {
		self.MarkPersistentBit(false);
		self.RunFxEvent("Campaigner_Normal");
    }
	//------------------------------------------------------------------------------------------------------------------------
};
