namespace HUD
{
	const int MAX_MESSAGES = 7; //Must be 7 or less
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const int time)
	{
		ShowMessage(array<kStr>={msg1}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const kStr &in msg2, const int time)
	{
		ShowMessage(array<kStr>={msg1, msg2}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const kStr &in msg2, const kStr &in msg3, const int time)
	{
		ShowMessage(array<kStr>={msg1, msg2, msg3}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const kStr &in msg2, const kStr &in msg3, const kStr &in msg4, const int time)
	{
		ShowMessage(array<kStr>={msg1, msg2, msg3, msg4}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const kStr &in msg2, const kStr &in msg3, const kStr &in msg4,
						const kStr &in msg5, const int time)
	{
		ShowMessage(array<kStr>={msg1, msg2, msg3, msg4, msg5}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const kStr &in msg2, const kStr &in msg3, const kStr &in msg4,
						const kStr &in msg5, const kStr &in msg6, const int time)
	{
		ShowMessage(array<kStr>={msg1, msg2, msg3, msg4, msg5, msg6}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(const kStr &in msg1, const kStr &in msg2, const kStr &in msg3, const kStr &in msg4,
						const kStr &in msg5, const kStr &in msg6, const kStr &in msg7, const int time)
	{
		ShowMessage(array<kStr>={msg1, msg2, msg3, msg4, msg5, msg6, msg7}, time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ShowMessage(array<kStr> &lines, const int time)
	{
		int linesLength = int(lines.length());
		int linesNeeded = MAX_MESSAGES - linesLength;
		
		if (linesNeeded < 0)
		{
			lines.resize(MAX_MESSAGES);
		}
		else
		{
			int halfLinesNeeded = linesNeeded / 2;
			for (int i = 0; i < halfLinesNeeded; i++)
				lines.insertAt(0, "");
			
			int bottomLinesNeeded = halfLinesNeeded;
			if (linesNeeded % 2 == 1)
				bottomLinesNeeded += 1;
			for (int i = 0; i < bottomLinesNeeded; i++)
				lines.insertLast("");
		}
		
		for (int i = 0; i < MAX_MESSAGES; i++)
		{
			Game.PrintLine(lines[(MAX_MESSAGES - 1) - i], i, time);
		}
	}
	//------------------------------------------------------------------------------------------------------------------------
	void ClearMessages()
	{
		for (int i = 0; i < MAX_MESSAGES; i++)
		{
			Game.PrintLine("", i, 10);
		}
	}
	//------------------------------------------------------------------------------------------------------------------------
}
