namespace String
{
	array<kStr> asciiChars = {
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", ' ', '!', '"', "", "", '%', '&', '\'', '(', ')', '*', '+', ',', '-', ".", "/", '0', '1', '2', '3', '4', '5', '6',
		'7', '8', '9', ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N',
		'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f',
		'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ""
	};

	const kStr STRINGLENGTH_KEY = ";L;";
	//------------------------------------------------------------------------------------------------------------------------
	// If s already contains STRINGLENGTH_KEY then this will return an incorrect length
	//------------------------------------------------------------------------------------------------------------------------
	int Length(kStr &in s)
	{
		return (s + STRINGLENGTH_KEY).IndexOf(STRINGLENGTH_KEY);
	}
	//------------------------------------------------------------------------------------------------------------------------
	bool IsEmpty(const kStr &in s)
	{
		return s.Hash() == 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// uint to string
	//------------------------------------------------------------------------------------------------------------------------
	kStr UInt(const uint value)
	{
		if (value & Math::UBIT31 != 0)
		{
			kStr result;
			array<int> uintDigits = {8,4,6,3,8,4,7,4,1,2};
			array<int> intDigits = Math::Digits(value & Math::MAX_INT, true);
			intDigits.resize(10);
			int carry = 0;
			int num = 0;
			for (int i = 0; i < 10; i++)
			{
				num = intDigits[i] + uintDigits[i] + carry;
				if (num >= 10)
				{
					carry = 1;
					num %= 10;
				}
				else
				{
					carry = 0;
				}
				result = "" + num + result;
			}
			
			return result;
		}
		
		return "" + value;
	}
	//------------------------------------------------------------------------------------------------------------------------
	array<int> SplitInt(const kStr &in s, kStr &in c)
	{
		array<kStr> entries = Split(s, c);
		array<int> result;
		for (int i = 0; i < int(entries.length()); i++)
		{
			result.insertLast(entries[i].Atoi());
		}
		return result;
	}
	//------------------------------------------------------------------------------------------------------------------------
	array<kStr> Split(kStr &in s, kStr &in c)
	{
		int length = Length(s);
		array<kStr> result;
		if (length > 0)
		{
			int8 sepCharID = c[0];
			kStr entry = "";
			for (int i = 0; i < length; i++)
			{
				int8 charID = s[i];
				if (charID == sepCharID)
				{
					result.insertLast(entry);
					entry = "";
					continue;
				}
				entry += asciiChars[charID];
			}
			result.insertLast(entry);
		}
		return result;
	}
	//------------------------------------------------------------------------------------------------------------------------
	kStr CharAt(kStr &in s, int index)
	{
		int8 c = s[index];
		return c >= 0 ? asciiChars[c] : "";
	}
	//------------------------------------------------------------------------------------------------------------------------
}
