namespace Time
{
	float mapStartTime;
	//------------------------------------------------------------------------------------------------------------------------
	float FromNow(const float timeOffset)
	{
		return Game() + timeOffset;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Diff(const float time)
	{
		return Math::Fabs(Game() - time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	bool Reached(const float timeTarget)
	{
		return Game() >= timeTarget;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Game()
	{
		return GameVar::GetFloat(GV_BP_KEY_GAMETIME);
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Map()
	{
		return Diff(mapStartTime);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void SetMapTime()
	{
		mapStartTime = Game();
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Normalize(const float from, const float to)
	{
		float length = to - from;
		if (length <= 0.0f)
			return 1.0f;
		
		return Math::Clampf(Diff(from) / length, 0.0f, 1.0f);
	}
	//------------------------------------------------------------------------------------------------------------------------
}
