#include "BP_Addons/scripts/BP_Common_Map.cpp"
#include "scripts/BP/JH_Common_Shared.cpp"

const uint16 OPEN_MENU_BUTTONS = (BC_MAPZOOMIN|BC_MAPZOOMOUT);

const int NEWGAME_KEY_HUBID = 1;
const int NEWGAME_KEYBIT = 31;
const int NEWGAME_MAPID = 64; //map to warp to OnNewGame if not already in the map
const int NEWGAME_MAP_WARPTID = 10000;

bool isNewGame;
float menuDisableTime;
kActor@ map;

//------------------------------------------------------------------------------------------------------------------------
void OnMapNewGame()
{
	if (Game.GetCurrentMapID() != NEWGAME_MAPID)
	{
		//Warp to newgame map
		PlayLoop.StartWarp(playerActor, NEWGAME_MAP_WARPTID, NEWGAME_MAPID);
		Game.HaltMapScript(SCRIPT_MAP_COMMON_START);
		Wait(); //Need to wait to make this script not continue to execute
	}
	
	isNewGame = true;
	BP_NewGame();
}
//------------------------------------------------------------------------------------------------------------------------
void OnMapStart(kActor@ instigator)
{
	BP_MapStart();
	
	@map = Actor::Spawn(JH_AT_MAP, playerActor.Origin(), playerActor.Yaw(), playerActor.SectorIndex());
	
	//Check if newgame (by checking if player has a key you get at the start of the game. Keys are cleared by a newgame being called)
	if (!Inventory::HasKey(NEWGAME_KEY_HUBID, NEWGAME_KEYBIT))
		OnMapNewGame();
	
	//Start common map tick
	Game.CallDelayedMapScript(SCRIPT_MAP_COMMON_TICK, instigator, 0.0f);
	
	//if a cinematic is already playing then wait for it to finish (e.g. the death cinematic)
	WaitUntil(Cinema::IsFinished);
}
//------------------------------------------------------------------------------------------------------------------------
void OnMapTick()
{
	Input::Tick();
	
	//Custom Menu
	if (Time::Reached(menuDisableTime) && !Player.Locked() && !Cinema::IsActive() && Input::Pressing(OPEN_MENU_BUTTONS))
	{
		menuDisableTime = Time::FromNow(5.0f);
		//HUD::ShowMessage("Welcome warrior", "You are great", 300);
	}
}
//------------------------------------------------------------------------------------------------------------------------
